From 1d673d82a75c4960ed708850ddaa043b840bba11 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Oct 10 2020 02:44:02 +0000
Subject: [PATCH 1016/2232] Permit duplicate C++ names of extern functions


C++ has overloading so that's fine.

---

diff --git a/syntax/types.rs b/syntax/types.rs
index 5ec7d26..5bac76e 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -51,8 +51,7 @@ impl<'a> Types<'a> {
         }
 
         let mut type_names = UnorderedSet::new();
-        let mut cxx_function_names = UnorderedSet::new();
-        let mut rust_function_names = UnorderedSet::new();
+        let mut function_names = UnorderedSet::new();
         for api in apis {
             // The same identifier is permitted to be declared as both a shared
             // enum and extern C++ type, or shared struct and extern C++ type.
@@ -117,15 +116,10 @@ impl<'a> Types<'a> {
                     rust.insert(ident);
                 }
                 Api::CxxFunction(efn) | Api::RustFunction(efn) => {
-                    let cxx_fn = (&efn.receiver, &efn.ident.cxx);
-                    let rust_fn = (&efn.receiver, &efn.ident.rust);
-                    let cxx_duplicate = !cxx_function_names.insert(cxx_fn);
-                    if !rust_function_names.insert(rust_fn) {
+                    // Note: duplication of the C++ name is fine because C++ has
+                    // function overloading.
+                    if !function_names.insert((&efn.receiver, &efn.ident.rust)) {
                         duplicate_name(cx, efn, &efn.ident.rust);
-                    } else if cxx_duplicate {
-                        // Insert into cxx_function_names either way, but hide
-                        // error if we're already erroring on the rust name.
-                        duplicate_name(cx, efn, &efn.ident.cxx);
                     }
                     for arg in &efn.args {
                         visit(&mut all, &arg.ty);

